<?php
	require_once($_ENV["DS_SCRIPTS"]."/utils.php");
	require_once($_ENV["DS_SCRIPTS"]."/token_formatter.php");
	
		function progress_bar ($caption, $percent, $text = null) {
		global $input;
		
		$height = $input["bar_height"]."px";
		
		$html = <<<HTML
			<progress max="100" value="$percent" style="height: $height; width: @px"></progress>
HTML;
		
		return $html;
	}
	
	function progress_knob ($caption, $percent, $text = null) {
		global $input;
		
		$thickness = (int)$input["bar_thickness"] * 0.1;
		
		$size = "@";
		$fgcolor = $input["fgcolor"];
		$bgcolor = $input["bgcolor"];
		
		if ($input["wheel_rounded"]) {
			$linecap = "round";
		} else {
			$lincap = "";
		}
		
		$html = <<<HTML
      <input class="knob" value="$percent" data-linecap="$linecap" data-thickness="$thickness" data-fgColor="$fgcolor" data-bgColor="$bgcolor" data-width="$size" data-height="$size" data-displayInput="false"/>
HTML;
	
		return $html;
	}
		
	function battery_stats () {
		
		$info = array();
		///Developer/Xcode\ 3.2.6/SDKs/MacOSX10.6.sdk/System/Library/Frameworks/IOKit.framework/Versions/A/Headers/pwr_mgt/IOPM.h
		
		/*
		[456] =>     | |     +-o AppleSmartBattery  <class AppleSmartBattery, id 0x1000001ef, registered, matched, active, busy 0 (0 ms), retain 6>
    [457] =>     | |         {
    [458] =>     | |           "ExternalConnected" = Yes
    [459] =>     | |           "TimeRemaining" = 123
    [460] =>     | |           "InstantTimeToEmpty" = 65535
    [461] =>     | |           "ExternalChargeCapable" = Yes
    [462] =>     | |           "FullPathUpdated" = 1397346604
    [463] =>     | |           "CellVoltage" = (4089,4060,4069,0)
    [464] =>     | |           "Voltage" = 12218
    [465] =>     | |           "BatteryInvalidWakeSeconds" = 30
    [466] =>     | |           "AdapterInfo" = 0
    [467] =>     | |           "MaxCapacity" = 4553
    [468] =>     | |           "PermanentFailureStatus" = 0
    [469] =>     | |           "Manufacturer" = "SMP"
    [470] =>     | |           "Location" = 0
    [471] =>     | |           "CurrentCapacity" = 2108
    [472] =>     | |           "LegacyBatteryInfo" = {"Amperage"=2638,"Flags"=7,"Capacity"=4553,"Current"=2108,"Voltage"=12218,"Cycle Count"=819}
    [473] =>     | |           "FirmwareSerialNumber" = 48
    [474] =>     | |           "BatteryInstalled" = Yes
    [475] =>     | |           "PackReserve" = 200
    [476] =>     | |           "CycleCount" = 819
    [477] =>     | |           "DesignCapacity" = 5770
    [478] =>     | |           "OperationStatus" = 58371
    [479] =>     | |           "ManufactureDate" = 15458
    [480] =>     | |           "AvgTimeToFull" = 123
    [481] =>     | |           "BatterySerialNumber" = "W0103T94RE1KB"
    [482] =>     | |           "BootPathUpdated" = 1397006022
    [483] =>     | |           "PostDischargeWaitSeconds" = 120
    [484] =>     | |           "Temperature" = 3013
    [485] =>     | |           "UserVisiblePathUpdated" = 1397346844
    [486] =>     | |           "InstantAmperage" = 2683
    [487] =>     | |           "ManufacturerData" = <000000000201000a01640000034b383603303041034c474300120000>
    [488] =>     | |           "MaxErr" = 1
    [489] =>     | |           "FullyCharged" = No
    [490] =>     | |           "DeviceName" = "bq20z451"
    [491] =>     | |           "IOGeneralInterest" = "IOCommand is not serializable"
    [492] =>     | |           "Amperage" = 2638
    [493] =>     | |           "IsCharging" = Yes
    [494] =>     | |           "DesignCycleCount9C" = 1000
    [495] =>     | |           "PostChargeWaitSeconds" = 120
    [496] =>     | |           "AvgTimeToEmpty" = 65535
    [497] =>     | |         }
		*/
		
		$command = "/usr/sbin/ioreg -c AppleSmartBattery -w0";
		exec($command, $results);
		$results = implode("\n", $results);
		
		if (preg_match("/\+\-o AppleSmartBattery\s+<[^>]+>.*\{(.*)\}/is", $results, $matches)) {

			$current_capacity = null;
			$max_capacity = null;
			$info = array();

			$lines = explode("\n", $matches[0]);
			
			/*
			
			[464] =>     | |           "Voltage" = 12218
	    [486] =>     | |           "InstantAmperage" = 2683
	    
			NSNumber *watt =  [NSNumber numberWithDouble:[Amperage doubleValue] / 1000 * [Voltage doubleValue] / 1000];
      
			2.683 * 12.218

			$watts = ($amps / 1000) * (Voltage / 1000);
			*/
						
			foreach ($lines as $line) {
				
				if (preg_match("/\"CurrentCapacity\" = (\d+)/i", $line, $matches)) {
					$info["current_capacity"] = (int)$matches[1];
					continue;
				}
				if (preg_match("/\"MaxCapacity\" = (\d+)/i", $line, $matches)) {
					$info["max_capacity"] = (int)$matches[1];
					continue;
				}
				if (preg_match("/\"DesignCapacity\" = (\d+)/i", $line, $matches)) {
					$info["design_capacity"] = (int)$matches[1];
					continue;
				}
				if (preg_match("/\"CycleCount\" = (\d+)/i", $line, $matches)) {
					$info["cycle_count"] = (int)$matches[1];
					continue;
				}
				if (preg_match("/\"TimeRemaining\" = (\d+)/i", $line, $matches)) {
					$info["time_remaining"] = (int)$matches[1] * 60;
					continue;
				}
				
				if (preg_match("/\"Temperature\" = (\d+)/i", $line, $matches)) {
					$temp = (int)$matches[1];
					$c = round($temp / 100, -1);
					
					$info["temperature"] = array( "f" => $c * 1.8 + 32,
																				"c" => $c);
					continue;
				}
				
				if (preg_match("/\"ExternalConnected\" = (\w+)/i", $line, $matches)) {
					$info["external_connected"] = $matches[1];
					continue;
				}			  
				
				if (preg_match("/\"Voltage\" = (\d+)/i", $line, $matches)) {
					$info["voltage"] = (int)$matches[1];
					continue;
				}
				
				if (preg_match("/\"InstantAmperage\" = (\d+)/i", $line, $matches)) {
					$info["amperage"] = (int)$matches[1];
					continue;
				}
			}
			
			// capacity
			$percent = ($info["current_capacity"] / $info["max_capacity"]) / 0.01;
			$percent_formatted = number_format($percent, 1);
			$percent_formatted = round($percent_formatted);
			$info["capacity"] = $percent_formatted;
			
			// health
			$percent = ($info["max_capacity"] / $info["design_capacity"]) / 0.01;
			$percent_formatted = number_format($percent, 1);
			$percent_formatted = round($percent_formatted);
			$info["health"] = $percent_formatted;
			
			if ($info["external_connected"] == "No") {
				$info["time_remaining"] = gmdate("H:i", $info["time_remaining"]);
			} else {
				$info["time_remaining"] = null;
			}
			
			// ??? this is broken I think
			$info["watts"] = ($info["amperage"] / 1000) * ($info["voltage"] / 1000);
		}
		
		return $info;
	}
		
	$stats = battery_stats();
	
	// parse format
	$tokens = array("%" => $stats["capacity"]."%",
									"c" => $stats["cycle_count"],
									"h" => $stats["health"]."%",
									"T" => $stats["temperature"]["f"]."°",
									"t" => $stats["time_remaining"],
									"w" => progress_knob("", $stats["capacity"]),
									"b" => progress_bar("", $stats["capacity"]),
									);
	
	$wheel_size = $input["wheel_size"];
	$bar_width = $input["bar_width"];
	
	if ($input["format"]) {
		$format = $input["format"];
	} else {
		
		$details = "";
		
		if (($input["kind"] != 1) && ($input["percent"])) {
			$details = "%";
		}
		
		if ($input["health"]) {
			if ($input["cycles"]) {
				$details .= "\nh `health` (c `cycles`)";
			} else {
				$details .= "\nh `health`";
			}
		}
		
		if ($stats["time_remaining"] && $input["time_remaining"]) {
			$details .= "\nt `remaining`";
		}
		
		switch ($input["kind"]) {
			case 1:
				$format = "% $details";
				break;
			case 2:
				$format = "{<[b:$bar_width][$details]>}";
				break;
			case 3:
				$format = "{<[w:$wheel_size][$details]>}";
				break;
		}
		
	}

	$parser = new TokenFormatter($format, $tokens);
	$parser->set_table_css_class("text-style");
	$parser->set_td_css_class("text-style");
	echo $parser->parse();
?>