<?php
	
	require_once($_ENV["DS_SCRIPTS"]."/utils.php");
	require_once($_ENV["DS_SCRIPTS"]."/token_formatter.php");
			
	function progress_bar ($caption, $percent, $text = null) {
		global $input;
		
		$height = $input["bar_height"]."px";
		
		$html = <<<HTML
			<progress max="100" value="$percent" style="height: $height; width: @px"></progress>
HTML;
		
		return $html;
	}
	
	function progress_knob ($caption, $percent, $text = null) {
		global $input;
		
		$thickness = $input["thickness"] * 0.1;
		$size = "@";
		$fgcolor = $input["fgcolor"];
		$bgcolor = $input["bgcolor"];
		
		if ($input["wheel_rounded"]) {
			$linecap = "round";
		} else {
			$lincap = "";
		}
		
		$html = <<<HTML
      <input class="knob" value="$percent" data-linecap="$linecap" data-thickness="$thickness" data-fgColor="$fgcolor" data-bgColor="$bgcolor" data-width="$size" data-height="$size" data-displayInput="false"/>
HTML;
	
		return $html;
	}
		
	function disk_stats () {
		global $input;
		
		$lines = array();
		$command = "/bin/df -PHl";
		if ($handle = popen($command, "r")) {
		    while (!feof($handle)) $lines[] = fgets($handle, 4096);
		}

		/*
			Filesystem     Size   Used  Avail Capacity  Mounted on
			/dev/disk0s2   499G   373G   126G    75%    /
			/dev/disk1s1   102M   2.9M    99M     3%    /Volumes/My Special Disk
			/dev/disk2s1   102M   3.0M    99M     3%    /Volumes/Disk Image
		*/

		// /?? make this a pref? we don't have a table param though for long lists....
		//$ignore = array("/dev", "/net", "/home");
		$disks = array();
		foreach ($lines as $line) {
			if (preg_match("/^([a-z0-9\/-_]+)\s+([0-9.]+\w{1})\s+([0-9.]+\w{1})\s+([0-9.]+\w{1})\s+([0-9.]+%)\s+(.*)/i", $line, $matches)) {
				$columns["filesystem"] = $matches[1];
				$columns["size"] = $matches[2];
				$columns["used"] = $matches[3];
				$columns["available"] = $matches[4];
				$columns["capacity"] = rtrim($matches[5], "%");
				$columns["where"] = $matches[6];
				
				$disks[] = $columns;
			}
		}
		
		return $disks;
	}
		
	//$input["format"] = "@b n %\n";
	//$input["format"] = "<[n][%][w]>";
	//$input["format"] = "n % w";
	//$input["format"] = "<[w:18][n %]>";
			
	$disks = disk_stats();
	$lines = array();
	
	foreach ($disks as $disk) {
		
		// filter only internal disks 
		if ($input["only_internal"] && (!preg_match("/^\/dev\/disk0/", $disk["filesystem"]))) continue;
		
		// parse format
		$tokens = array("v" => $disk["where"],		// ??? display name!
										"n" => exec($_ENV["DS_TOOLS"]."/displayname \"".$disk["where"]."\""),
										"%" => $disk["capacity"]."%",
										"u" => $disk["used"],
										"t" => $disk["size"],
										"w" => progress_knob("", $disk["capacity"]),
										"b" => progress_bar("", $disk["capacity"]),
										);
		
		if ($input["format"]) {
			$string = $input["format"];
		} else {
			
			$wheel_size = $input["wheel_size"];
			$bar_width = $input["bar_width"];
			
			//if ($input["usage_stats"]) $stats = "[%][(u/t)]";
			//if ($input["disk_name"]) $stats = "[n]".$stats;
			
			if (($input["usage_stats"]) && ($input["disk_name"])) {
				$stats = "[n\n% (u/t)]";
			} elseif ($input["usage_stats"]) {
				$stats = "[% (u/t)]";
			}	elseif ($input["disk_name"]) {
				$stats = "[n\n]";
			}
			
			// text
			if ($input["kind"] == 1) $string = "<$stats>";
			
			// bar
			if ($input["kind"] == 2) $string = "<[b:$bar_width]$stats>";
			
			// wheel
			if ($input["kind"] == 3) $string = "<[w:$wheel_size]$stats>";
				
		}
		
		//$string = "b:$bar_width";
		$parser = new TokenFormatter($string, $tokens);
		$lines[] = $parser->parse();
	}
	
	$outer = "{r}";
	$tokens = array("r" => implode("", $lines));
	
	$parser = new TokenFormatter($outer, $tokens);
	$parser->set_table_css_class("text-style");
	$parser->set_td_css_class("text-style");
	echo $parser->parse();
	
	
?>