<?php
	require_once($_ENV["DS_SCRIPTS"]."/utils.php");
	
	define(ORGANIZE_BY_EVENT, 0);
	define(ORGANIZE_BY_DAY, 1);
	define(ORGANIZE_BY_MONTH, 2);
	
	//$input["df"] = 30;
	//$input["attrs"] = true;
	//$input["cal"] = "Personal";
	//$input["prefix"] = "- ";
	
	$primary_bullet = $input["primary_bullet"];
	$secondary_bullet = $input["secondary_bullet"];
	$column_indent = $input["indent"];
	$cal = $input["cal"];
	$days_into_future = $input["df"];
	$organize = $input["organize"];
	$organize_by_day_format = $input["odf"];
	$organize_by_month_format = $input["omf"];
	
	function indent_str ($length) {
		global $column_indent;
		$indent = "";
		for ($i=0; $i < $length; $i++) $indent .= $column_indent;
		return $indent;
	}
	
	// print header
	if ($input["header"]) {
		if ($cal) {
			print("$cal:\n");
		} else 
			print("Events:\n");
	}
	
	if ($input["cal"]) {
		$results = shell_exec("\"".getcwd()."/calhelper\" -cals \"$cal\" -events $days_into_future");
	} else {
		$results = shell_exec("\"".getcwd()."/calhelper\" -events $days_into_future");
	}
	//print_r($results);
	//exit;
	
	if ($xml = simplexml_load_string($results)) {
		//print_r($xml);
		//exit;
		
		$events = array();
		
		foreach ($xml as $value) {
			
			// print title and date
			date_default_timezone_set($value->timeZone);
			//$date = date('l jS \of F Y \a\t h:i:s A', (int)$value->startTimeStamp);
			
			$month = date($organize_by_month_format, (int)$value->timeStamp);
			$day_of_month = date($organize_by_day_format, (int)$value->timeStamp);
			
			$event = array();
			$event["title"] = $value->title;
			$event["date"] = $value->date;
			$event["calendar"] = $value->calendar;
			$event["allday"] = (int)$value->allday;
			$event["timestamp"] = (int)$value->timeStamp;
			$event["time"] = $value->time;
			$attrs = null;
			
			// get attributes
			if (($input["attrs"]) && ($value->location || $value->url || $value->notes || $value->attendees)) {
				if ($value->location) $attrs["location"] = $value->location;
				if ($value->url) $attrs["url"] = $value->url;
				if ($value->notes) $attrs["notes"] = $value->notes;
				if ($value->attendees) {
					$attendees = "";
					foreach ($value->attendees->attendee as $attendee) {
						$attendees = $attendees.$attendee->commonName.", ";
					}
					$attendees = rtrim($attendees, ", ");
					//print("    Attendees: $attendees\n");
					$attrs["attendees"] = $attendees;
				}
			}
			
			$event["attributes"] = $attrs;
			
			// add to list
			$events[$month][$day_of_month][] = $event;
			
		}
		//print_r($events);
		
		if ($organize == ORGANIZE_BY_EVENT) {
			$category_bullet = "";
			$event_bullet = $primary_bullet;
		} else {
			$category_bullet = $primary_bullet;
			$event_bullet = $secondary_bullet;
		}
	
		foreach ($events as $month => $days_for_month) {
			if ($organize == ORGANIZE_BY_MONTH) print("$category_bullet $month:\n");
			foreach ($days_for_month as $day => $events_for_month) {
				if ($organize == ORGANIZE_BY_DAY) print("$category_bullet $day:\n");
				foreach ($events_for_month as $event) {

					$title = $event["title"];
					$date = $event["date"];
					$calendar = $event["calendar"];
					$time = $event["time"];
					
					if ($organize == ORGANIZE_BY_MONTH) {
						if ($event["allday"] == 0) {
							$info = "(".date('jS', $event["timestamp"])." at $time)";
						} else {
							$info = "(".date('jS', $event["timestamp"]).")";
						}
					} elseif ($organize == ORGANIZE_BY_DAY) {
						if ($event["allday"] == 0) {
							$info = "($time)";
						} else {
							$info = "";
						}
					} else {
						$info = "($date)";
					}
					
					if ($organize == ORGANIZE_BY_EVENT) {
						print("$event_bullet $title $info\n");
					} else {
						print(indent_str(2)."$event_bullet $title $info\n");
					}

					if ($event["attributes"]) {
						foreach ($event["attributes"] as $key => $value) print(indent_str(6)."$key: $value\n");
					}
				}
			}
		}
		
	}
?>
