<?php

	// http://michaelwelburn.com/2011/11/02/comparing-weather-apis/
	require_once($_ENV["DS_SCRIPTS"]."/utils.php");
	require_once($_ENV["DS_SCRIPTS"]."/token_formatter.php");
		
	//$input["where"] = "1225955";
	//$input["theme"] = "flat_white";
	
	//$location = $input["where"];
	$where = $input["where"];
	$where = str_replace(",", "", $where);
	$where = urlencode($where);

	// get woeid from location
	$url = "http://query.yahooapis.com/v1/public/yql?q=select%20*%20from%20geo.places%20where%20text%3D%22$where%22&format=xml";
	
	if ($xml = @simplexml_load_file($url)) {
		//print_r($xml);
		foreach ($xml->results->place as $place) {
			// $place->placeTypeName
			//print("$place->name, $place->admin1 ($place->country) = $place->woeid\n");
			$location = $place->woeid;
			break;
		}
	} else {
		print("Invalid location or server error.");
		exit;
	}
	
	// get temperature units
	$units = $input["units"];
	
	// default to have valid value for the xml
	if (!$units) $units = "f";
	
	// build URL
	$url = "http://xml.weather.yahoo.com/forecastrss?w=$location&u=$units";
	
	function node_attributes_to_array ($node) {
		$attributes = array();
		foreach ($node->attributes() as $key => $value) {
			$attributes[$key] = (string)$value;
		}
		return $attributes;
	}
			
	function get_condition_image ($code) {
		global $input;
		
		$condition_image = getcwd()."/images/".$input["theme"]."/".$code.".png";
		if (file_exists($condition_image)) {
			return "<img src=\"$condition_image\" width=\"@\" height=\"@\"/>";
		} else {
			return " ";
		}
	}
	
	function parse_forecast ($forecast) {
		global $input;
		
		$tokens = array(
														"d" => $forecast["day"],
														"D" => $forecast["date"],
														"l" => $forecast["low"]."°",
														"h" => $forecast["high"]."°",
														"t" => $forecast["text"],
														"i" => get_condition_image($forecast["code"]),
														);
		
		//$string = "<[i:16][d][l - h][t]>";
		$string = $input["forecast_format"];
		
		$parser = new TokenFormatter($string, $tokens);
		$parser->set_td_css_class("text-style");
		return $parser->parse();
	}	
	
	function build_format_string ($weather) {
		global $input;
		$parts = array();
		
		if ($input["condition_image"] > 0) $parts[] = "i:".$input["condition_image"];
		if ($input["location"]) $parts[] = "c, C ";
		if ($input["temp"]) $parts[] = "T ";
		if ($input["condition_text"]) $parts[] = "t ";
		
		if (($input["wind"]) || ($input["humidity"]) || ($input["visibility"]) || ($input["pressure"]) || ($input["sunrise"]) || ($input["sunset"])) {
			$parts[] = "{";
			if ($input["wind"]) $parts[] = "<[`Wind:`][w]>";
			if ($input["humidity"]) $parts[] = "<[`Humidity:`][h]>";
			if ($input["visibility"]) $parts[] = "<[`Visibility:`][v]>";
			if ($input["pressure"]) $parts[] = "<[`Pressure:`][p]>";
			if ($input["sunrise"]) $parts[] = "<[`Sunrise:`][S]>";
			if ($input["sunset"]) $parts[] = "<[`Sunset:`][s]>";			
			$parts[] = "}";
		}
		
		/*
		if ($input["wind"]) $parts[] = "`Wind:` w\n";
		if ($input["humidity"]) $parts[] = "`Humidity:` h\n";
		if ($input["visibility"]) $parts[] = "`Visibility:` v\n";
		if ($input["pressure"]) $parts[] = "`Pressure:` p\n";
		if ($input["sunrise"]) $parts[] = "`Sunrise:` S\n";
		if ($input["sunset"]) $parts[] = "`Sunset:` s\n";
		*/
		
		if ($input["forecast"]) $parts[] = "{f}";		
		
		return implode("", $parts);
	}
		
	function parse_weather ($weather) {
		global $input;
		//$string = "@i:128\n+++c, +++C\n           T t\n\n{f}";
		
		if ($input["weather_format"]) {
			$string = $input["weather_format"];
		} else {
			$string = build_format_string($weather);
		}
		
		$forecast_output = "";
		foreach ($weather["forecasts"] as $forecast) {
			$forecast_output .= parse_forecast($forecast);
		}

		$tokens = array(
										
										// location
										"c" => $weather["location"]["city"],
										"r" => $weather["location"]["region"],
										"C" => $weather["location"]["country"],
										
										// window
										"w" => $weather["wind"]["speed"].$weather["units"]["speed"],
										
										// atmosphere
										"h" => $weather["atmosphere"]["humidity"]."%",
										"v" => $weather["atmosphere"]["visibility"].$weather["units"]["distance"],
										"p" => $weather["atmosphere"]["pressure"].$weather["units"]["pressure"],
										
										// astronomy
										"S" => $weather["astronomy"]["sunrise"],
										"s" => $weather["astronomy"]["sunset"],
										
										// condition
										"t" => $weather["condition"]["text"],
										"T" => $weather["condition"]["temp"]."°",	
										"i" => get_condition_image($weather['condition']["code"]),
										
										// time
										"d" => $weather["condition"]["date"],
										
										// forecast
										"f" => $forecast_output,
																				
										);
				
		$parser = new TokenFormatter($string, $tokens);
		$parser->set_td_css_class("text-style");
		return $parser->parse();
	}	
		
	if ($xml = @simplexml_load_file($url)) {
		//print_r($xml);
		
		$weather = array();

		// current weather
		$nodes = $xml->channel->children('yweather', true);
		foreach ($nodes as $key => $value) {
			$weather[$key] = node_attributes_to_array($value);
		}

		$nodes = $xml->channel->item->children('yweather', true);
		foreach ($nodes as $key => $value) {			
			switch ($key) {
				case 'location': {
					$weather[$key] = node_attributes_to_array($value);
					break;
				}
				case 'condition': {
					$weather[$key] = node_attributes_to_array($value);
					break;
				}
				case 'forecast': {
					$day = array();
					$weather["forecasts"][] = node_attributes_to_array($value);
					break;
				}
			}
		}
		
		if (count($weather)) {
			echo parse_weather($weather);
		} else {
			print($xml->channel->item->title);
		}
	} else {
		print("Server error occurred.");
	}
	

?>