<?php	
	require_once($_ENV["DS_SCRIPTS"]."/utils.php");
	require_once($_ENV["DS_SCRIPTS"]."/token_formatter.php");
	
	$maximum_length = $input["maximum_length"];

	// no playing song
	if ($input["itunes"] == "(null)") {
		print("No Song");
		die;
	}

	// decode json from itunes applescript
	$itunes = json_decode($input["itunes"], true);
	
	$artist = str_truncate($itunes["artist"], $maximum_length);
	$album = str_truncate($itunes["album"], $maximum_length);
	$track = str_truncate($itunes["track"], $maximum_length);
	$image = "";
	
	// cover image
	if ($input["cover"]) {
		
		$cover = dirname(__FILE__)."/cover";
		
		// if there is nothing playing then delete the cover
		if (!$artist) @unlink($cover);
		
		if (file_exists($cover)) {
			$css = "";
			
			if ($input["cover_round"]) $css .= "image-round ";
			if ($input["cover_reflection"]) $css .= "image-reflection ";
			if ($input["cover_border"]) $css .= "image-border ";
			
			$image = "<img src=\"$cover\" class=\"$css\"/>";
		} else {
			$image = "";
		}
	}
	
	$tokens = array("t" => $track,
									"A" => $artist,
									"a" => $album,
									"c" => $image,
									);
	
	if ($input["format"]) {
		$string = $input["format"];
	} else {
		$parts = array();
		if ($input["track"]) $parts[] = "t";
		if ($input["artist"]) $parts[] = "A";
		if ($input["album"]) $parts[] = "a";
		if ($input["cover"]) $parts[] = "c";
		$string = implode("\n", $parts);
	}
	
	$parser = new TokenFormatter($string, $tokens);
	echo $parser->parse();
	
	//if ($input["track"]) print("<span>$track</span><br/>");
	//if ($input["artist"]) print("<span>$artist</span><br/>");
	//if ($input["album"]) print("<span>$album</span><br/>");
	
?>