<?php

	/**
	 * COMMAND LINE UTILITIES
	 */
	function script_input () {
		$input = array();
		foreach($GLOBALS["argv"] as $key => $value) {
			$value = trim($value, "\n");
			$value = ltrim($value, "-");
			$pair = explode("=", $value);
			if (count($pair) == 2) {
				$pair[1] = trim($pair[1], "\"");
				$line_array = explode("\n", $pair[1]);
				if (count($line_array) > 1) {
					$input[$pair[0]] = $line_array;
				} else {
					$input[$pair[0]] = $pair[1];
				}
			} else {
				$input[$value] = true;
			}
		}
		return $input;
	}
	
	/**
	 * STRING UTILITIES
	 */
	function str_truncate($string,$length=100,$append="...") {
	  $string = trim($string);

	  if(strlen($string) > $length) {
	    $string = wordwrap($string, $length);
	    $string = explode("\n",$string);
	    $string = array_shift($string) . $append;
	  }

	  return $string;
	}
	/**
	 * FILE UTILITIES
	 */
	function user_directory () {
		return "/Users/".exec("whoami");
	}

	function expand_tilde_path ($path) {
		return str_replace("~", user_directory(), $path);
	}

	function abbreviate_tilde_path ($path) {
		return str_replace(user_directory(), "~", $path);
	}
	
	/**
	 * MEMORY UTILITIES
	 */
	
	function bytes_to_str($bytes, $precision = 2) {
			$block_size = 1024;

	    $kilobyte = $block_size;
	    $megabyte = $kilobyte * $block_size;
	    $gigabyte = $megabyte * $block_size;
	    $terabyte = $gigabyte * $block_size;

	    if (($bytes >= 0) && ($bytes < $kilobyte)) {
	        return $bytes . ' bytes';

	    } elseif (($bytes >= $kilobyte) && ($bytes < $megabyte)) {
	        return round($bytes / $kilobyte, $precision) . 'KB';

	    } elseif (($bytes >= $megabyte) && ($bytes < $gigabyte)) {
	        return round($bytes / $megabyte, $precision) . 'MB';

	    } elseif (($bytes >= $gigabyte) && ($bytes < $terabyte)) {
	        return round($bytes / $gigabyte, $precision) . 'GB';

	    } elseif ($bytes >= $terabyte) {
	        return round($bytes / $terabyte, $precision) . 'TB';
	    } else {
	        return $bytes . ' bytes';
	    }
	}

	function convert_memory_string_to_bytes ($string) {
		$m = array("K", "KB", "KiB");
		$k = array("M", "MB", "MiB");
		$g = array("G", "GB", "GiB");
	}
	
	/**
	 * CSS
	 */

	function print_css_text_style () {
		$color = $_ENV["DS_TEXT_COLOR"];
		$family = $_ENV["DS_FONT_FAMILY"];
		$size = $_ENV["DS_FONT_SIZE"];
		
		$str = <<<EOT
			color: $color;
			font-size: $size;
			font-family: "$family";
EOT;
		
		print($str);
	}
	
	function progress_bar_css ($bgcolor = "black", $fgcolor = "white", $border_width = "0", $border_color = "white", $rounded = true, $padding = 2) {
		
		if ($rounded) {
			$container_radius = "12px";
			$bar_radius = "8px";
		} else {
			$container_radius = "0";
			$bar_radius = "0";
		}
		
		$padding .= "px";
		
		$html = <<<HTML
		<style>
			progress[value] {
			  -webkit-appearance: none;
			}
		
			progress[value]::-webkit-progress-bar {
			  background-color: $bgcolor;
			  border-radius: $container_radius;
				padding: $padding;
				border: $border_width solid $border_color;
			}
		
			progress[value]::-webkit-progress-value {
				background-color: $fgcolor;
				border-radius: $bar_radius;
			}
		</style>
HTML;

		return $html;
	}
	
	$input = script_input();
?>